package org.ten60.netkernel.test.app;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.*;
import org.netkernel.layer0.representation.impl.*;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.ten60.netkernel.test.representation.TestEnginePreBuiltTestList;
import org.w3c.dom.Document;

public class TestViewAccessor extends StandardAccessorImpl
{
	public static final String TITLE="Xunit Tests - ";
	
	public TestViewAccessor()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext context) throws Exception
	{
		String testid=context.getThisRequest().getArgumentValue("id");
		String format=context.getThisRequest().getArgumentValue("format");
		context.setCWU(null);
		
		INKFRequest req=context.createRequest("active:testEntry");
		req.addArgument("id", testid);
		IHDSNode test=(IHDSNode)context.issueRequest(req);
		
		req=context.createRequest("active:testList");
		req.addArgument("tests", (String)test.getFirstValue("/test/uri").toString().trim());
		req.addArgument("space", (String)test.getFirstValue("/test/space").toString().trim());
		req.addArgument("version", (String)test.getFirstValue("/test/version").toString().trim());
		req.setRepresentationClass(TestEnginePreBuiltTestList.class);
		TestEnginePreBuiltTestList testlist=(TestEnginePreBuiltTestList)context.issueRequest(req);
		
		if(format.equals("html"))
		{
			Document testlistDoc = testlist.getImmutableTestList();
			req=context.createRequest("active:xslt");
			req.addArgumentByValue("operand", testlistDoc);
			req.addArgument("operator","res:/org/ten60/netkernel/test/app/style-test-view.xsl");
			req.addArgumentByValue("test", test);
			req.setRepresentationClass(String.class);
			Object result=context.issueRequest(req);
			INKFResponse resp=context.createResponseFrom(result);
			
			String name=test.getFirstValue("/test/name").toString();
			resp.setHeader("WrappedControlPanel", TITLE+name);
			String subtitle="from "+test.getFirstValue("/test/space").toString()+" v"+test.getFirstValue("/test/version").toString();
			resp.setHeader("WrappedControlPanelSubtitle", subtitle);
		}
		else
		{	INKFResponse resp=context.createResponseFrom(testlist.getImmutableTestList());
			resp.setMimeType("text/xml");
		}
	}
	
}
